﻿from tcaxPy import *
from util.gdiFont import *

import re

def tcaxPy_Init():
    global font   # Font和GdiFont效果差不多
    global fontsize
    global GdiFont
    fontsize = GetVal(val_FontSize)
    font = InitFont(GetVal(val_FontFileName), GetVal(val_FaceID), fontsize, GetVal(val_Spacing), GetVal(val_SpaceScale), 0xFFFFFF, 0, 0)
    GdiFont = gfInitFont(GetVal(val_FontFaceName), fontsize, GetVal(val_Spacing), GetVal(val_SpaceScale), 0, False)   #GDIfont

def tcaxPy_User():
    pass


def tcaxPy_Fin():
    FinFont(font)

def checkacw(str):          # 判斷內框

    Ppath = ppath(str)
    
    if Ppath[0]==Ppath[-1]:        #字體矢量有重複最後坐標點的習慣 貌似重複的基本是外框 不過總有bug的地方 總之取首尾不同的 扔掉最後重複
        Ppath.pop()
    return check_clockwise(Ppath)   # 设为内框

#構建一個本項和後項結合的list 比方說poly為[(1,1),(2,2),(3,3),(4,4)] 則新list為[((1,1),(2,2)),((2,2),(3,3)),((3,3),(4,4)),((4,4),(1,1))]
def segments(poly):       #網上照搬
    return zip(poly, poly[1:] + [poly[0]])     

def check_clockwise(poly):      #判斷順時針 網上搬 算法之前判斷用的極值求叉積法 總有凹多邊形不準確 這個遍歷所有點算叉積 最後以總和的正負來判斷
    clockwise = False
    if (sum(x0*y1 - x1*y0 for ((x0, y0), (x1, y1)) in segments(poly))) < 0:   # 叉積为負值是逆時針
        clockwise = not clockwise
    return clockwise


def ppath(str):   # 從str 將路徑儲存為 [(1,1),(2,2),(3,3),(4,4)] 這種格式 b 標籤捨棄中間點 做直線考慮
    if str[0] != 'm':
        str = 'm'+ str
    sb = re.split('m|l|b ',str)     # re是一个正则表达式Module，这里的split其实就是字符串的split函数的翻版，只是可以对分隔符用正则
    ppath = []
    for s in sb:
        b = s.split()
        if len(b) > 1:
            if b[-1]=='c':
                ppath.append((int(b[-3]),int(b[-2])))
            else:
                ppath.append((int(b[-2]),int(b[-1])))
    ppath.pop()   # 所有路徑 首尾都相同 捨棄掉最後重複
    return ppath

def polycmp(poly1,poly2):    #判斷多邊形是否在另一個多邊形內
    result = True
    if poly2[-1]==poly2[0]:
        poly2.pop()
    for p1 in poly1:
        x1,y1= p1
        if not pointinpoly(x1,y1,poly2):  #遍歷多邊形所有點是否在多邊形內 
            result = False
    return result

def pointinpoly(x,y,poly): # 判斷一個點是否在多邊形內 網上搬

    n = len(poly)
    inside = False

    p1x,p1y = poly[0]
    for i in range(n+1):
        p2x,p2y = poly[i % n]
        if y > min(p1y,p2y):
            if y <= max(p1y,p2y):
                if x <= max(p1x,p2x):
                    if p1y != p2y:
                        xints = (y-p1y)*(p2x-p1x)/(p2y-p1y)+p1x
                    if p1x == p2x or x <= xints:
                        inside = not inside
        p1x,p1y = p2x,p2y

    return inside


def tcaxPy_Main(_i, _j, _n, _start, _end, _elapk, _k, _x, _y, _a, _txt):

    ASS_BUF  = []        # used for saving ASS FX lines

    #############################
    # TODO: write your codes here #

    dx = _x - int(_a / 2 + 0.5)
    dy = _y - int(fontsize / 2 + 0.5)

    outline = gfGetOutline(GdiFont, _txt, dx,dy)

    draw = outline.split('m')
    num = len(draw)


    acdl = []   #用來儲存內框矢量
    cdl = []    #儲存外框矢量
    if _i>-1 :
        for i in range(num):     #遍歷所有m標籤矢量 判斷內外框 并進行儲存
            if draw[i] == '':
                continue
 
            if checkacw(draw[i]):     
                acd = 'm'+draw[i]
                acdl.append(acd)
            else:
                cd = 'm'+draw[i] 
                cdl.append(cd)   
   
    cdlcopy = cdl[:]   #複製一遍list
    for acd in acdl:    
        index = -1
        for i in range(len(cdlcopy)):
            if polycmp(ppath(acd),ppath(cdlcopy[i])):     #遍歷所有內框外框 判斷內框是否在外框範圍內
                if index == -1:
                    index = i
                else:                                    
                    if polycmp(ppath(cdlcopy[i]),ppath(cdlcopy[index])):   #若存在多個可匹配的範圍 取最小的框 如"回"字
                        index = i
        if index != -1:
            cdl[index] += acd    #將內框矢量 加在外框矢量之後
        else:
            cdl.append(acd)  #若沒找到匹配的外框 則作為外框 這個有可能是順時針逆時針的判斷問題 也有可能是字體設計的問題 總之是保險

    for cd in cdl:   #繪製
        posX = randint(-_a, _a) + randint(-10, 10)
        posY = randint(-fontsize , fontsize ) + randint(-10, 10)
        EFT = an(7) + move(posX, posY, 0, 0, 0, 500) + p(4)
        ass_main(ASS_BUF, SubL(_start, _end), EFT, cd)

    #############################

    return (ASS_BUF, None)





