﻿from tcaxPy import *

def tcaxPy_Init():
    global font
    global fontsize

    fontsize = GetVal(val_FontSize)
    font = InitFont(GetVal(val_FontFileName), GetVal(val_FaceID), fontsize, GetVal(val_Spacing), GetVal(val_SpaceScale), 0xFFFFFF, 0, 0)


def tcaxPy_User():
    pass


def tcaxPy_Fin():
    FinFont(font)

def GetPixelPointFromPix(PIX, InitPosX, InitPosY):      # 将方形PIX[1][0]xPIX[1][1]范围的pixel扫描成一个list，保存位置、RGBA、label信息
    pixel = []
    label = 0
    for h in range(PIX[1][1]):
        posY = InitPosY + h
        for w in range(PIX[1][0]):
            posX = InitPosX + w
            idx = 4 * (h * PIX[1][0] + w)
            pixR = PIX[2][idx + 0]
            pixG = PIX[2][idx + 1]
            pixB = PIX[2][idx + 2]
            pixA = PIX[2][idx + 3]
            pixel.append([(posX, posY), (pixR, pixG, pixB, pixA), label])
    
    return pixel

def DeleteRepeat(labelset):     # 删除list中的重复元素

    labelset2 = []

    [labelset2.append(label) for label in labelset if not label in labelset2]

    return labelset2      


def UnionTwoLists(list1, list2):     # 合并2个list，默认它们含有相同元素
    for elem in list1:
        if elem in list2:
            continue
        else:
            list2.append(elem)

    return list2


def UnionLabelSet(labelset):        # 整理labelset，合并
    labelset = sorted(labelset, key=lambda k: k[0]) # 排序
    labelset = DeleteRepeat(labelset) # 刪除重複

    labelset2 = []


    for label in labelset:
        if labelset2 == []:               #第一個 label 直接添加
            labelset2.append(label) 

        else:
            flag = 0
            for i in range(len(labelset2)):   #遍歷之前的label找交集 若存在交集 向對應位置 添加未存在的元素
                #tcaxLog(label2) 
                if (label[0] not in labelset2[i]) and (label[1] in labelset2[i]): 
                    flag = 1
                    labelset2[i].append(label[0])
                elif (label[0] in labelset2[i]) and (label[1] not in labelset2[i]):
                    flag = 1
                    labelset2[i].append(label[1])
                elif (label[0] in labelset2[i]) and (label[1] in labelset2[i]):
                    flag = 1
            if flag == 0:   # 若不存在交集 則另存
                labelset2.append(label)

    #tcaxLog(labelset2)           
    return labelset2
    

def tcaxPy_Main(_i, _j, _n, _start, _end, _elapk, _k, _x, _y, _a, _txt):

    ASS_BUF  = []        # used for saving ASS FX lines

    #############################
    # TODO: write your codes here #

    PIX = TextPix(font, _txt)

    InitPosX = _x - int(_a / 2 + 0.5) + PIX[0][0]
    InitPosY = _y - int(fontsize / 2 + 0.5) + PIX[0][1]

    pixel = GetPixelPointFromPix(PIX, InitPosX, InitPosY)

    num = len(pixel)
    label = 0
    labelset = []

    # 1-pass
    for i in range(num):
        if pixel[i][1][3] != 0:     # 如果是有效像素
            if i == 0:              # 如果是第1个像素，没有左面和上面的相邻像素，需要单独考虑
                label += 1
                pixel[i][2] = label
            elif i % PIX[1][0] == 0:                # 如果是第1列像素，没有左面的相邻像素，需要单独考虑
                uppixelindex = i - PIX[1][0]        # 取上面的相邻像素index
                if pixel[uppixelindex][2] != 0:      
                    pixel[i][2] = pixel[uppixelindex][2]    # 如果上面的相邻像素是有效像素，就把上面像素的label赋给当前像素
                else:                                       # 如果上面的相邻像素不是有效像素，就把label加1，然后赋给当前像素
                    label += 1
                    pixel[i][2] = label
            elif i <= PIX[1][0] - 1:        # 如果是第1行像素，没有上面的相邻像素，需要单独考虑
                leftpixelindex = i - 1
                if pixel[leftpixelindex][2] != 0:
                    pixel[i][2] = pixel[leftpixelindex][2]
                else:
                    label += 1
                    pixel[i][2] = label
            else:                           # 同时考虑上面和左面的相邻像素是否是有效像素
                uppixelindex = i - PIX[1][0]
                leftpixelindex = i - 1
                if pixel[leftpixelindex][2] != 0 and pixel[uppixelindex][2] != 0:                   # 如果上面和左面的相邻像素都是有效像素，
                    pixel[i][2] = min(pixel[leftpixelindex][2], pixel[uppixelindex][2])             # 就把它们的label的最小值赋给当前像素
                    if pixel[leftpixelindex][2] != pixel[uppixelindex][2]:                          # 如果它们的label不相等，
                        labelset.append(sorted([pixel[leftpixelindex][2], pixel[uppixelindex][2]])) # 就把它们的label组成一个list加入labelset
                elif pixel[leftpixelindex][2] != 0 and pixel[uppixelindex][2] == 0:                 # 如果上面的相邻像素不是有效像素，
                    pixel[i][2] = pixel[leftpixelindex][2]                                          # 就把左面像素的label赋给相邻像素
                elif pixel[leftpixelindex][2] == 0 and pixel[uppixelindex][2] != 0:                 # 如果左面的相邻像素不是有效像素，
                    pixel[i][2] = pixel[uppixelindex][2]                                            # 就把上面像素的label赋给相邻像素
                else:                                                                               # 如果如果上面和左面的相邻像素都不是有效像素，
                    label += 1                                                                      # 把label加1，赋给当前像素
                    pixel[i][2] = label
    #tcaxLog(pixel)					
    labelset = UnionLabelSet(labelset)	

    #print(labelset)			
      
    # 2-pass    #這個地方寫法冗長 比較亂 沒仔細想 # 这下面的一些操作可以不做，只要同一个labelset[]的用同一种EFT即可

    for i in range(len(pixel)):   #按labelset 修改相同 label
        if pixel[i][2] != 0:
            for j in range(len(labelset)):
                if pixel[i][2] in labelset[j]:                                            
                    pixel[i][2] = min(labelset[j])
                 
    #tcaxLog(min(labelset[j]))
    rndx = []
    rndy = []
    cor = []
    labelbuf = []

    for i in range(len(pixel)):   # 將不連續的label修改成最小連續數列

        label = pixel[i][2]
        if label != 0:
            if label not in labelbuf:
                labelbuf.append(label)
            pixel[i][2] = labelbuf.index(label) +1


    for i in range(len(labelbuf)):  # 按照label個數生成隨機位置和顏色list
        rndx.append(randint(-50, 50))
        rndy.append(randint(-100, 100))
        cor.append(RandRGB())

    #tcaxLog(sorted(labelbuf))

    #if _i == 0 and _j == 2:
    #    tcaxLog(pixel)
  
    for i in range(len(pixel)):   #繪製  
        label = pixel[i][2]

        if label != 0:

            EFT = move(pixel[i][0][0] + rndx[label-1], pixel[i][0][1] + rndy[label-1], pixel[i][0][0], pixel[i][0][1], 0, 500) + alpha(255 - pixel[i][1][3]) + color1(cor[label-1])
            ass_main(ASS_BUF, SubL(_start, _end, 0, Pix_Style), EFT, DrawPoint())


    #############################

    return (ASS_BUF, None)





